// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "V8IdleDeadline.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "core/dom/ContextFeatures.h"
#include "core/dom/Document.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/TraceEvent.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8IdleDeadline::wrapperTypeInfo = { gin::kEmbedderBlink, V8IdleDeadline::domTemplate, V8IdleDeadline::refObject, V8IdleDeadline::derefObject, V8IdleDeadline::trace, 0, 0, V8IdleDeadline::preparePrototypeAndInterfaceObject, V8IdleDeadline::installConditionallyEnabledProperties, "IdleDeadline", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent, WrapperTypeInfo::GarbageCollectedObject };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in IdleDeadline.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& IdleDeadline::s_wrapperTypeInfo = V8IdleDeadline::wrapperTypeInfo;

namespace IdleDeadlineV8Internal {

static void didTimeoutAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    v8::Local<v8::Object> holder = info.Holder();
    IdleDeadline* impl = V8IdleDeadline::toImpl(holder);
    v8SetReturnValueBool(info, impl->didTimeout());
}

static void didTimeoutAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMGetter");
    IdleDeadlineV8Internal::didTimeoutAttributeGetter(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void timeRemainingMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    IdleDeadline* impl = V8IdleDeadline::toImpl(info.Holder());
    v8SetReturnValue(info, impl->timeRemaining());
}

static void timeRemainingMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    IdleDeadlineV8Internal::timeRemainingMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

} // namespace IdleDeadlineV8Internal

const V8DOMConfiguration::AccessorConfiguration V8IdleDeadlineAccessors[] = {
    {"didTimeout", IdleDeadlineV8Internal::didTimeoutAttributeGetterCallback, 0, 0, 0, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

const V8DOMConfiguration::MethodConfiguration V8IdleDeadlineMethods[] = {
    {"timeRemaining", IdleDeadlineV8Internal::timeRemainingMethodCallback, 0, 0, v8::None, V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype},
};

static void installV8IdleDeadlineTemplate(v8::Local<v8::FunctionTemplate> functionTemplate, v8::Isolate* isolate)
{
    functionTemplate->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    if (!RuntimeEnabledFeatures::requestIdleCallbackEnabled())
        defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "IdleDeadline", v8::Local<v8::FunctionTemplate>(), V8IdleDeadline::internalFieldCount, 0, 0, 0, 0, 0, 0);
    else
        defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "IdleDeadline", v8::Local<v8::FunctionTemplate>(), V8IdleDeadline::internalFieldCount,
            0, 0,
            V8IdleDeadlineAccessors, WTF_ARRAY_LENGTH(V8IdleDeadlineAccessors),
            V8IdleDeadlineMethods, WTF_ARRAY_LENGTH(V8IdleDeadlineMethods));
    v8::Local<v8::ObjectTemplate> instanceTemplate = functionTemplate->InstanceTemplate();
    ALLOW_UNUSED_LOCAL(instanceTemplate);
    v8::Local<v8::ObjectTemplate> prototypeTemplate = functionTemplate->PrototypeTemplate();
    ALLOW_UNUSED_LOCAL(prototypeTemplate);


}

v8::Local<v8::FunctionTemplate> V8IdleDeadline::domTemplate(v8::Isolate* isolate)
{
    return V8DOMConfiguration::domClassTemplate(isolate, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8IdleDeadlineTemplate);
}

bool V8IdleDeadline::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8IdleDeadline::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

IdleDeadline* V8IdleDeadline::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value)
{
    return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : 0;
}

void V8IdleDeadline::refObject(ScriptWrappable* scriptWrappable)
{
}

void V8IdleDeadline::derefObject(ScriptWrappable* scriptWrappable)
{
}

} // namespace blink
