// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "V8InputDeviceCapabilities.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8InputDeviceCapabilitiesInit.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "core/dom/ContextFeatures.h"
#include "core/dom/Document.h"
#include "core/frame/LocalDOMWindow.h"
#include "core/frame/UseCounter.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/TraceEvent.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8InputDeviceCapabilities::wrapperTypeInfo = { gin::kEmbedderBlink, V8InputDeviceCapabilities::domTemplate, V8InputDeviceCapabilities::refObject, V8InputDeviceCapabilities::derefObject, V8InputDeviceCapabilities::trace, 0, 0, V8InputDeviceCapabilities::preparePrototypeAndInterfaceObject, V8InputDeviceCapabilities::installConditionallyEnabledProperties, "InputDeviceCapabilities", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent, WrapperTypeInfo::GarbageCollectedObject };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in InputDeviceCapabilities.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& InputDeviceCapabilities::s_wrapperTypeInfo = V8InputDeviceCapabilities::wrapperTypeInfo;

namespace InputDeviceCapabilitiesV8Internal {

static void firesTouchEventsAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    v8::Local<v8::Object> holder = info.Holder();
    InputDeviceCapabilities* impl = V8InputDeviceCapabilities::toImpl(holder);
    v8SetReturnValueBool(info, impl->firesTouchEvents());
}

static void firesTouchEventsAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMGetter");
    UseCounter::countIfNotPrivateScript(info.GetIsolate(), currentExecutionContext(info.GetIsolate()), UseCounter::V8InputDeviceCapabilities_FiresTouchEvents_AttributeGetter);
    InputDeviceCapabilitiesV8Internal::firesTouchEventsAttributeGetter(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void constructor(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ConstructionContext, "InputDeviceCapabilities", info.Holder(), info.GetIsolate());
    InputDeviceCapabilitiesInit deviceInitDict;
    {
        if (!isUndefinedOrNull(info[0]) && !info[0]->IsObject()) {
            exceptionState.throwTypeError("parameter 1 ('deviceInitDict') is not an object.");
            exceptionState.throwIfNeeded();
            return;
        }
        V8InputDeviceCapabilitiesInit::toImpl(info.GetIsolate(), info[0], deviceInitDict, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    RawPtr<InputDeviceCapabilities> impl = InputDeviceCapabilities::create(deviceInitDict);
    v8::Local<v8::Object> wrapper = info.Holder();
    wrapper = impl->associateWithWrapper(info.GetIsolate(), &V8InputDeviceCapabilities::wrapperTypeInfo, wrapper);
    v8SetReturnValue(info, wrapper);
}

} // namespace InputDeviceCapabilitiesV8Internal

const V8DOMConfiguration::AccessorConfiguration V8InputDeviceCapabilitiesAccessors[] = {
    {"firesTouchEvents", InputDeviceCapabilitiesV8Internal::firesTouchEventsAttributeGetterCallback, 0, 0, 0, 0, v8::DEFAULT, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

void V8InputDeviceCapabilities::constructorCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SCOPED_SAMPLING_STATE("blink", "DOMConstructor");
    if (!info.IsConstructCall()) {
        V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::constructorNotCallableAsFunction("InputDeviceCapabilities"));
        return;
    }

    if (ConstructorMode::current(info.GetIsolate()) == ConstructorMode::WrapExistingObject) {
        v8SetReturnValue(info, info.Holder());
        return;
    }

    InputDeviceCapabilitiesV8Internal::constructor(info);
}

static void installV8InputDeviceCapabilitiesTemplate(v8::Local<v8::FunctionTemplate> functionTemplate, v8::Isolate* isolate)
{
    functionTemplate->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    if (!RuntimeEnabledFeatures::inputDeviceCapabilitiesEnabled())
        defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "InputDeviceCapabilities", v8::Local<v8::FunctionTemplate>(), V8InputDeviceCapabilities::internalFieldCount, 0, 0, 0, 0, 0, 0);
    else
        defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "InputDeviceCapabilities", v8::Local<v8::FunctionTemplate>(), V8InputDeviceCapabilities::internalFieldCount,
            0, 0,
            V8InputDeviceCapabilitiesAccessors, WTF_ARRAY_LENGTH(V8InputDeviceCapabilitiesAccessors),
            0, 0);
    functionTemplate->SetCallHandler(V8InputDeviceCapabilities::constructorCallback);
    functionTemplate->SetLength(0);
    v8::Local<v8::ObjectTemplate> instanceTemplate = functionTemplate->InstanceTemplate();
    ALLOW_UNUSED_LOCAL(instanceTemplate);
    v8::Local<v8::ObjectTemplate> prototypeTemplate = functionTemplate->PrototypeTemplate();
    ALLOW_UNUSED_LOCAL(prototypeTemplate);


}

v8::Local<v8::FunctionTemplate> V8InputDeviceCapabilities::domTemplate(v8::Isolate* isolate)
{
    return V8DOMConfiguration::domClassTemplate(isolate, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8InputDeviceCapabilitiesTemplate);
}

bool V8InputDeviceCapabilities::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8InputDeviceCapabilities::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

InputDeviceCapabilities* V8InputDeviceCapabilities::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value)
{
    return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : 0;
}

void V8InputDeviceCapabilities::refObject(ScriptWrappable* scriptWrappable)
{
}

void V8InputDeviceCapabilities::derefObject(ScriptWrappable* scriptWrappable)
{
}

} // namespace blink
