// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "V8MediaRecorderOptions.h"

#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8MediaRecorderOptions::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, MediaRecorderOptions& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    v8::TryCatch block(isolate);
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> mimeTypeValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "mimeType")).ToLocal(&mimeTypeValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (mimeTypeValue.IsEmpty() || mimeTypeValue->IsUndefined()) {
            // Do nothing.
        } else {
            V8StringResource<> mimeType = mimeTypeValue;
            if (!mimeType.prepare(exceptionState))
                return;
            impl.setMimeType(mimeType);
        }
    }

}

v8::Local<v8::Value> toV8(const MediaRecorderOptions& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8MediaRecorderOptions(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8MediaRecorderOptions(const MediaRecorderOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasMimeType()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "mimeType"), v8String(isolate, impl.mimeType()))))
            return false;
    }

    return true;
}

MediaRecorderOptions NativeValueTraits<MediaRecorderOptions>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    MediaRecorderOptions impl;
    V8MediaRecorderOptions::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
